!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Module DisturbEnv
!
!   * Developer: SUGIYAMA Ko-ichiro, ODAKA Masatsugu
!   * Version: $Id: distset.f90,v 1.1 2011-03-30 13:53:06 sugiyama Exp $ 
!   * Tag Name: $Name: arare4-20111215 $
!   * Change History: 
!
!== Overview 
!
!ΥǥեͤͿ뤿Υ롼. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!  * ǽʾΥפ䤹
!  * 顼 gf4f90io 
!  * randomfile ϤΥ֥롼
!

module DistSet
  !
  !ΥǥեͤͿ뤿Υ롼. 
  !
  
  !⥸塼ɤ߹
  use dc_message, only: MessageNotify
  use gridset,    only:DimXMin,         &!  X β
    &                  DimXMax,         &!  X ξ
    &                  RegXMin,         &!  X β
    &                  RegXMax,         &!  X ξ
    &                  DimZMin,         &!  Z β
    &                  DimZMax,         &!  Z ξ
    &                  RegZMin,         &!  Z β
    &                  RegZMax,         &!  Z ξ
    &                  MarginX,         &! ׻ΰΥޡ
    &                  MarginZ,         &! ׻ΰΥޡ
    &                  DelZ,            &! Z ι
    &                  SpcNum,          &! Žؼο
    &                  XMin, XMax,      &! 
    &                  ZMin, ZMax,      &! 
    &                  x_X,             &! X ɸ(顼ʻ)
    &                  z_Z               ! Z ɸ(顼ʻ)
  use fileset,    only:RandomFile        ! ե
  use basicset,   only:                 &
    &                  SpcWetMolFr,     &!Žʬν
    &                  MolWtWet,        &!Žʬʬ
    &                  MolWtDry,        &!ʬʬ
    &                  xz_TempBasicZ,   &! ܾβ
    &                  xz_PressBasicZ,  &! ܾΰ
    &                  xz_ExnerBasicZ,  &! ̵
    &                  xza_MixRtBasicZ   ! ܾκ
  use Boundary, only:  BoundaryXCyc_xza , &!
    &                  BoundaryZSym_xza,  & 
    &                  BoundaryXCyc_xz , &!
    &                  BoundaryZSym_xz , &
    &                  BoundaryXCyc_pz , &!
    &                  BoundaryZSym_pz 
  use ECCM,     only:  ECCM_Wet


  !ۤηػ
  implicit none

  !°
  private

  !ѿ
  real(8), parameter, save :: Pi = 3.1415926535897932385d0 !߼Ψ

  !public
  public distset_pottemp
  public distset_exner
  public distset_mixrt
  public distset_velx

contains
  
  subroutine distset_pottemp(cfgfile, xz_PotTemp)
    ! ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile
    real(8), intent(out)     :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
    character(20)    :: Type =""
    real(8)         :: DelMax = 0.0d0   !κ
    real(8)         :: XcRate = 0.0d0   !濴(ʿ)ΰФ
    real(8)         :: XrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
    real(8)         :: YcRate = 0.0d0   !濴(ʿ)ΰФ
    real(8)         :: YrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
    real(8)         :: ZcRate= 0.0d0    !濴(ľ)ΰФ
    real(8)         :: ZrRate = 0.0d0   !Ⱦ(ľ)ΰФ
    real(8)         :: Zpos = 0.0d0     ! Z ɸ [m] (Therma-Random )
    real(8)         :: Xc               !濴(X)
    real(8)         :: Yc               !濴(Y)
    real(8)         :: Zc               !濴(ľ)
    real(8)         :: Xr               !Ⱦ(X)
    real(8)         :: Yr               !Ⱦ(Y)
    real(8)         :: Zr               !Ⱦ(ľ)
    real(8)         :: Random           !ե뤫
    real(8)         :: beta(DimXMin:DimXMax, DimZMin:DimZMax)
                                        !κͤФ
    real(8)         :: RandomNum(DimXMin:DimXMax)
    real(8)         :: RandomNum2(DimXMin:DimXMax)
    integer         :: i, j, k, n

    ! NAMELIST ե
    NAMELIST /disturbenv_pottemp/ Type, &
      & DelMax, XrRate, XcRate, YrRate, YcRate, ZrRate, ZcRate, Zpos

    ! namelist ɤ߹
    open (10, FILE=cfgfile)
    read(10, NML=disturbenv_pottemp)
    close(10)

    ! ֤η
    !  XMax ˤ MPI ޤ᤿ΰ褬äƤ
    Xr = minval( x_X, 1, x_X > (XMax - XMin) * XrRate )
    Xc = minval( x_X, 1, x_X > (XMax - XMin) * XcRate )
!    Yr = minval( y_Y, 1, y_Y > (YMax - YMin) * YrRate )
!    Yc = minval( y_Y, 1, y_Y > (YMax - YMin) * YcRate )
    Zr = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZrRate )
    Zc = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZcRate )
    
    ! Υפ
    select case(Type)
      
      ! ꤵ줿٤˥ʾͿ
    case ("Random")      

      ! ȯ
      do i = RegXMin, RegXMax
        call random_number(random)
        RandomNum(i) = random
      end do
      
      ! ΤȤƤϥȤʤ褦Ĵ. ʿѤκˤ. 
      do i = RegXMin, RegXmax
        RandomNum2(i) = RandomNum(i) - sum( RandomNum(RegXMin+1:RegXMax) ) / real(RegXMax - RegXMin, 8) 
      end do
    
      ! ꤵ줿٤˾֤. DelMax ϲ٤ʤΤ, ̤Ѵ. 
      do i = RegXMin, RegXMax
        xz_PotTemp(i, maxloc(z_Z, z_Z <= Zpos) - MarginZ - 1) = &
          & DelMax * RandomNum2(i) / xz_ExnerBasicZ(i, maxloc(z_Z, z_Z <= Zpos) - MarginZ - 1)
      end do
      
      ! ꤵ줿ɸ濴Ȥʬۤβ̾Ϳ. 
    case ("Gauss")
      do k = DimZMin, DimZMax
        do i = DimXMin, DimXMax
          xz_PotTemp(i,k) = &
            & DelMax * dexp( - ( (x_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1   &
            &                - ( (z_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) &
            & / xz_ExnerBasicZ(i,k)
        end do
      end do
    
      ! ꤵ줿ΰ˲̾Ϳ (Klemp and Wilhelmson, 1978) 
    case ("KW1978")
      do k = DimZMin, DimZMax
        do i = DimXMin, DimXMax
          beta(i,k) =                                 &
            & (                                       &
            &      ( ( x_X(i) - Xc ) / Xr ) ** 2.0d0  &
            &    + ( ( z_Z(k) - Zc ) / Zr ) ** 2.0d0  &
            &  ) ** 5.0d-1
        end do
      end do
      
      where ( beta < 1.0d0 )
        xz_PotTemp = DelMax * ( dcos( Pi * 5.0d-1 * beta ) ** 2.0d0 ) &
          &          / xz_ExnerBasicZ
      end where
      
      ! Hueso and Sanchez-Lavega Ϥ
    case ("HS2001")
      i = ( DimXMax - DimXMin - 10) / 2 
      k = minloc( z_Z, 1, z_Z > 2.5d4 ) - MarginZ
      n = int( 5.0d3 / DelZ )
      
      xz_PotTemp(i-n:i,k-n:k) = DelMax
      
      ! Skamarock and Klemp (1989)  Cold-bubble ¸
    case ("SK1989")
      do k = DimZMin, DimZMax
        do i = DimXMin, DimXMax
          beta(i,k) =                                 &
            & sqrt(                                   &
            &      ( ( x_X(i) - Xc ) / Xr ) ** 2.0d0  &
            &    + ( ( z_Z(k) - Zc ) / Zr ) ** 2.0d0  &
            &  )
        end do
      end do
      
      where ( beta < 1.0d0 )
        xz_PotTemp = 0.5d0*DelMax*(cos(pi*beta) + 1.0d0)
      end where
    end select
    
    ! 
    call BoundaryXCyc_xz( xz_PotTemp )
    call BoundaryZSym_xz( xz_PotTemp )
    
  end subroutine distset_pottemp

  subroutine distset_exner(cfgfile, xz_Exner)

    ! ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile
    real(8), intent(out)     :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
    character(20)   :: Type =""
    real(8)         :: DelMax = 0.0d0   !κ
    real(8)         :: XcRate = 0.0d0   !濴(ʿ)ΰФ
    real(8)         :: XrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
    real(8)         :: YcRate = 0.0d0   !濴(ʿ)ΰФ
    real(8)         :: YrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
    real(8)         :: ZcRate= 0.0d0    !濴(ľ)ΰФ
    real(8)         :: ZrRate = 0.0d0   !Ⱦ(ľ)ΰФ
    real(8)         :: Xc               !濴(X)
    real(8)         :: Yc               !濴(Y)
    real(8)         :: Zc               !濴(ľ)
    real(8)         :: Xr               !Ⱦ(X)
    real(8)         :: Yr               !Ⱦ(Y)
    real(8)         :: Zr               !Ⱦ(ľ)
    integer         :: i, j, k

    ! NAMELIST ե
    NAMELIST /disturbenv_exner/ Type, &
      & DelMax, XrRate, XcRate, YrRate, YcRate, ZrRate, ZcRate

    ! namelist ɤ߹    
    open (10, FILE=cfgfile)
    read(10, NML=disturbenv_exner)
    close(10)

    ! ֤η
    !  XMax ˤ MPI ޤ᤿ΰ褬äƤ
    Xr = minval( x_X, 1, x_X > (XMax - XMin) * XrRate )
    Xc = minval( x_X, 1, x_X > (XMax - XMin) * XcRate )
!    Yr = minval( y_Y, 1, y_Y > (YMax - YMin) * YrRate )
!    Yc = minval( y_Y, 1, y_Y > (YMax - YMin) * YcRate )
    Zr = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZrRate )
    Zc = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZcRate )

    ! ʡؿ. 
    select case (Type)    

      ! ꤵ줿, ʥʡؿξͿ. 
    case ("Gauss")
      do k = DimZMin, DimZMax
        do i = DimXMin, DimXMax
          xz_Exner(i,k) =                                             &
            & DelMax * dexp( - ( (x_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1 &
            &                - ( (z_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
        end do
      end do
    end select
    
    ! 
    call BoundaryXCyc_xz( xz_Exner )
    call BoundaryZSym_xz( xz_Exner )    
    
  end subroutine distset_exner


  subroutine distset_mixrt(cfgfile, xza_MixRt)
    ! ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile
    real(8), intent(out)     :: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, 1:SpcNum)
    character(20)   :: Type =""
    real(8)         :: DelMax = 0.0d0   !κ
    real(8)         :: XcRate = 0.0d0   !濴(ʿ)ΰФ
    real(8)         :: XrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
    real(8)         :: YcRate = 0.0d0   !濴(ʿ)ΰФ
    real(8)         :: YrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
    real(8)         :: ZcRate= 0.0d0    !濴(ľ)ΰФ
    real(8)         :: ZrRate = 0.0d0   !Ⱦ(ľ)ΰФ
    real(8)         :: XposMin = 0.0d0  !
    real(8)         :: XposMax = 0.0d0  !
    real(8)         :: ZposMin = 0.0d0  !
    real(8)         :: ZposMax = 0.0d0  !
    real(8)         :: Humidity = 0.0d0 !м
    real(8)         :: Xc               !濴(X)
    real(8)         :: Yc               !濴(Y)
    real(8)         :: Zc               !濴(ľ)
    real(8)         :: Xr               !Ⱦ(X)
    real(8)         :: Yr               !Ⱦ(Y)
    real(8)         :: Zr               !Ⱦ(ľ)
    integer         :: i, j, k, s
    real(8)         :: MolFrIni(SpcNum)
    real(8)         :: za_MolFr(DimZMin:DimZMax, SpcNum)

    ! NAMELIST ե
    NAMELIST /disturbenv_mixrt/ Type, &
      & DelMax, XrRate, XcRate, YrRate, YcRate, ZrRate, ZcRate, &
      & XposMin, XposMax, ZposMin, ZposMax, Humidity

    ! namelist ɤ߹    
    open (10, FILE=cfgfile)
    read(10, NML=disturbenv_mixrt)
    close(10)
    
    ! ֤η
    !  XMax ˤ MPI ޤ᤿ΰ褬äƤ
    Xr = minval( x_X, 1, x_X > (XMax - XMin) * XrRate )
    Xc = minval( x_X, 1, x_X > (XMax - XMin) * XcRate )
!    Yr = minval( y_Y, 1, y_Y > (YMax - YMin) * YrRate )
!    Yc = minval( y_Y, 1, y_Y > (YMax - YMin) * YcRate )
    Zr = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZrRate )
    Zc = minval( z_Z, 1, z_Z > (ZMax - ZMin) * ZcRate )

    ! 
    select case (Type)
    
      ! ꤵ줿ɸ濴ȤʬۤκͿ. 
    case ("Gauss")
      do k = DimZMin, DimZMax
        do i = DimXMin, DimXMax
          do s = 1, SpcNum
            xza_MixRt(i,:,s) =                                     &
              & DelMax                                             &
              & * dexp( - ( (x_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1   &
              &         - ( (z_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 )
          end do
        end do
      end do
    
      ! XposMin:XposMax,ZposMin:ZposMax ǰϤޤ줿ΰνμ٤򥼥ˤ뤿
      ! ܾȵοͿ
    case ("Dry")
      do s = 1, SpcNum
        do k = DimZMin,DimZMax  
          do i = DimXMin,DimXMax
            if (z_Z(k) >= ZposMin .AND. z_Z(k) < ZposMax &
              & .AND. x_X(i) >= XposMin .AND. x_X(i) < XposMax) then
              xza_MixRt(i,k,s) = - xza_MixRtBasicZ(i,k,s)
            end if
          end do
        end do
      end do
      
      ! Ϳ줿м٤ꤹ.
    case ("Humidity")
      MolFrIni = SpcWetMolFr(1:SpcNum) 

      ! ʿͤʤΤ, i=0 ׻. 
      call ECCM_Wet( MolFrIni, Humidity, xz_TempBasicZ(1,:), xz_PressBasicZ(1,:),  za_MolFr )
      
      !Υ򺮹Ѵ
      do s = 1, SpcNum
        do k = RegZMin, RegZMax
          do i = RegXMin, RegXMax
            xza_MixRt(i,k,s) = za_MolFr(k,s) * MolWtWet(s) / MolWtDry - xza_MixRtBasicZ(i,k,s)
          end do
        end do
      end do

    end select

    ! 
    call BoundaryXCyc_xza( xza_MixRt )
    call BoundaryZSym_xza( xza_MixRt )

  end subroutine distset_mixrt
  

  subroutine distset_VelX(cfgfile, pz_VelX)
    ! ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile
    real(8), intent(out)     :: pz_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
    character(20)   :: Type =""
    real(8)         :: Umax = 0.0d0     !濴(ʿ)ΰФ
    real(8)         :: ZposMin = 0.0d0  ! Z ɸ [m] (ü)
    real(8)         :: ZposMax = 0.0d0  ! Z ɸ [m] (ü)
    integer         :: i, j, k, b, u

    ! namelist 
    NAMELIST /disturbenv_VelX/ Type, Umax, ZposMin, ZposMax

    ! ͤɤ߽Ф
    open (10, FILE=cfgfile)
    read(10, NML=disturbenv_velx)
    close(10)
    
    select case(Type)
    
    case ("Takemi2007")
      !
      != 
      !* case "Takemi2007" Ǥη׻˱ľΤͿ˻Ѥ
      !* Ϳˤ, ʲΤ褦ʥХꥨ󤬤
      !  (1) Ϳ٤Ѥ
      !  (2) Τκ® (U_s) Ѥ
      !
      !  (1) ˤĤƤ, (a) 0 - 2.5 km, (b) 2.5 - 5.0 km, (c) 5.0 - 7.5 km 
      !  ѥ󤬤
      !  (2) ˤĤƤ, Takemi (2007) ǤǮӾپβپ
      !  ۤʤͤꤷƤ
      !
      !  ζ(Us), ʲ̤
      !  <ǮӾ>   (1) 5 m/s, (2) 10 m/s, (3) 15 m/s
      !  <پ> (1) 10 m/s, (2) 15 m/s, (3) 20 m/s
      !
      !* ηϼ (Takemi, 2007)   |
      !                                     /| 7.5 km
      !                                    / |
      !                                   /  |
      !                                  / |
      !                                   /| 5.0 km
      !                                  / |
      !                                 /  |
      !                                  / |
      !                                   /| 2.5 km
      !                                  / |
      !                                 /  |
      !                                  / |
      !---------------------------------+------------- 0.0 km
      !                                Us (m/s)
      !
      
      ! Ϳ٤
      ! Ϥι٤γʻ (B)  νγʻ (U) Ƿ
      do k = RegZMin+1, DimZMax
        if (z_Z(k) <= ZposMin .AND. ZposMin < z_Z(k+1)) then
          B = k
        end if
        
        if (z_Z(k) <= ZposMax .AND. ZposMax < z_Z(k+1)) then      
          U = k
        end if
      end do
      
      ! 嵭Ƿ᤿ʻBUδ֤˱ľΤͿ
      do k = RegZMin+1, U
        do i = DimXMin, DimXMax
          if (k < B) then
            pz_VelX(i,k) =  Umax
          else
            pz_VelX(i,k) =  Umax - (Umax / (z_Z(U) - z_Z(B)) * (z_Z(k) - z_Z(B)))
          end if
        end do
      end do
    end select

    !
    call BoundaryXCyc_pz( pz_VelX )
    call BoundaryZSym_pz( pz_VelX )

  end subroutine Distset_VelX

end module DistSet
